﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_HelpTables' ))
	Drop procedure dbo.A_DB_HelpTables
GO


Create  procedure dbo.A_DB_HelpTables
as
begin

--	use oktell_cc_temp
--	exec sp_spaceused
--	exec sp_helpdb oktell_cc_temp

--	use oktell
	exec sp_spaceused
	exec sp_helpdb oktell


-- Считает количество строк во всех таблицах основной БД

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#tabcnt' ))
		Drop table #tabcnt

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#tt' ))
		Drop table #tt

	
	--Create table #tabcnt ( id int identity(1,1), tablename nvarchar ( 200 ), cnt int )
	Create table #tabcnt ( name nvarchar(200), rows int, reserved nvarchar(100), data nvarchar (100), index_size nvarchar(100), unused nvarchar(100))
	
	Truncate table #tabcnt


	Declare tcursor Cursor For
		Select name 
		From sysobjects 
		Where xtype = 'U'

	Declare @sql nvarchar(1000)	
	Declare @tab_name varchar(500)

	Open tcursor
	Fetch Next From tcursor Into @tab_name

	While ( @@fetch_status = 0 ) Begin
		
		--Set @sql='Select ''' + @tab_name + ''', Count(*) From dbo.[' + @tab_name + ']'
		--Insert into #tabcnt (tablename, cnt )
		--   Exec sp_executesql @stmt =@sql

		Set @sql = ' Exec sp_spaceused  [' + @tab_name + ']'
		Insert into #tabcnt ( name, rows, reserved, data, index_size, unused )
		   Exec sp_executesql @stmt =@sql
		  
		Fetch Next From tcursor Into @tab_name
	End

	Close tcursor
	Deallocate tcursor

	Select *, 
		Case when ( rows = 0 ) then '?' else cast ( cast ( Cast ( Replace ( data, ' KB', '' ) as float ) * 1024 / rows as int ) as nvarchar(200)) end as for1row,
		object_id ( name ) as obj_id
		Into #tt
	From #tabcnt 
	Where rows >= 100
	Order by rows desc

	-- данные по таблицам базы
	--Select * from #tt t


	-------
	-- средний размер за неделю
	-------

	--  собственно таблица с неделями
	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#weeks' ))
		Drop table #weeks

	Create table #weeks ( id int, datestart datetime, datestop datetime )
	Declare @i int, @dtnow datetime

	Set @dtnow = cast ( Floor ( cast ( GetDate() as Float ) ) as DateTime )
	Set @i = 0

	while ( @i < 50 ) begin
		Insert into #weeks ( id, datestart, datestop )
		Values ( @i, DateAdd ( d, -((@i + 1) * 7), @dtnow ), DateAdd ( d, -(@i * 7), @dtnow ) )
		Set @i = @i + 1
	end

	--  тестики

	--Select w.id, Count ( * )
	--From A_CallCenter_UserStateHistory a
	--	Inner join #weeks w on a.TimeEnter between w.datestart and w.datestop
	--Group by w.id

	--Select Max ( cnt ) as maxcnt, Avg ( cnt ) as avgcnt, Min (cnt) as mincnt
	--From ( Select w.id, Count ( * ) as cnt
	--	From A_Stat_Connections_1x1 a
	--		Inner join #weeks w on a.TimeStart between w.datestart and w.datestop
	--	Group by w.id ) a


	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#t2' ))
		Drop table #t2

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#t3' ))
		Drop table #t3

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#t4' ))
		Drop table #t4


	--  столбцы дата/время
	--  минимальный индекс столбца дата/время
	Select t.obj_id, Min ( sc.colorder ) as colorder into #t3
	from #tt t
		Inner join syscolumns sc on sc.id = t.obj_id and sc.xtype = 61
	Group by t.obj_id

	--  название столбца в плюс	
	Select t.*, t3.colorder, sc.name as colname into #t2
	from #tt t
		Inner join syscolumns sc on sc.id = t.obj_id and sc.xtype = 61
		Inner join #t3 t3 on t3.obj_id = t.obj_id and t3.colorder = sc.colorder

	
	Create table #t4 ( obj_id int, dtcolname nvarchar(200), maxcnt int, mincnt int, avgcnt int )
	
	-- курсор по таблицам	

	Declare tcursor Cursor For
		Select t.obj_id, name, colname 
		From #t2 t

	Declare @col_name varchar(500), @objid int

	Open tcursor
	Fetch Next From tcursor Into @objid, @tab_name, @col_name

	While ( @@fetch_status = 0 ) Begin
		
		Set @sql = ' Select ' + cast ( @objid as nvarchar (100) )+ ', ''' + @col_name + ''', Max ( cnt ) as maxcnt, Min (cnt) as mincnt, Avg ( cnt ) as avgcnt
			From ( Select w.id, Count ( * ) as cnt
				From [' + @tab_name + '] a
				Inner join #weeks w on a.[' + @col_name + '] between w.datestart and w.datestop
			Group by w.id ) a '
	
		Insert into #t4 ( obj_id, dtcolname, maxcnt, mincnt, avgcnt )
		   Exec sp_executesql @stmt = @sql
		  
		Fetch Next From tcursor Into @objid, @tab_name, @col_name
	End

	Close tcursor
	Deallocate tcursor

	-- Объединяем данные
	-- Вывод исходных данных по таблице и размерам, а также в расчете количества данных за неделю
	Select tt.obj_id, tt.name, tt.rows, tt.reserved, tt.data, tt.index_size, tt.unused, 
		cast ( tt.for1row as nvarchar(100) ) + ' Bytes' as Size1Row, 
		t4.dtcolname as DateTimeColumn, 
		t4.maxcnt as MaxWeekRows, t4.mincnt as MinWeekRows, 
		t4.avgcnt as AvgWeekRows, 
		cast ( t4.avgcnt * tt.for1row / 1024 as nvarchar ( 100 ) ) + ' KB' as AvgWeekSize
	FROM #tt tt
		Inner join #t4 t4 on t4.obj_id = tt.obj_id


end
GO
