﻿if exists ( select * from sysobjects where id=object_id ( 'dbo.A_UserMessages_GetNew' ))
	Drop procedure dbo.A_UserMessages_GetNew
GO

Create Procedure [dbo].A_UserMessages_GetNew
	@iduser uniqueidentifier
as
begin
	Declare @allusers bit
	Set @allusers = 0
	if ( @iduser = '00000000-0000-0000-0000-000000000000' )
	   Set @allusers = 1	

	Select msg.Id, IdUserA, IsNull ( u1.Name, '???' ) as UserAName, IdUserB, IsNull ( u2.Name, '???' ) as UserBName, SentDate, Message, Viewed, ViewedDate 
	From A_UserMessages msg
		Left join A_Users u1 on IdUserA = u1.Id
		Left join A_Users u2 on IdUserB = u2.Id
	Where (( IdUserB = @iduser ) or ( @allusers = 1 ))
		and ( Viewed = 0 )
	Order by SentDate

	Select * From A_UserHistory
end
GO


if exists ( select * from sysobjects where id=object_id ( 'dbo.A_UserMessages_GetNewForActive' ))
	Drop procedure dbo.A_UserMessages_GetNewForActive
GO

Create Procedure [dbo].A_UserMessages_GetNewForActive
	@makeviewed bit = 1
as
begin	
	-- Достаем активных подключенных
	Declare @active table (id uniqueidentifier)

	-- По A_UserStateHistory. Тут дефолтные пользователи тоже попадают
	/*
	Insert into @active (id)
		Select id--, name
		From ( Select u.id, --u.Name, 
				IsNull (( Select Top 1 h.state as state
					From dbo.A_UserStateHistory h 
					Where h.UserId = u.id
					Order By h.TimeChange Desc ), 0) as state
			From dbo.A_Users u
			Group by u.id--, u.Name
			) a
		Where state > 0
		--Order by name
	*/

	-- По A_CallCenter_UserStateHistory. Тут без дефолтных пользователей и запрос проще
	Insert into @active (id)
		Select OperatorId
		From A_CallCenter_UserStateHistory h
			Inner join A_Users u on u.id = h.operatorid
		Where TimeLeave is null
		Group by OperatorId



	-- Выборка сообщений
	Select msg.Id, IdUserA, IsNull ( u1.Name, '???' ) as UserAName, IdUserB, IsNull ( u2.Name, '???' ) as UserBName, SentDate, Message, Viewed, ViewedDate 
	From A_UserMessages msg
		Left join A_Users u1 on IdUserA = u1.Id
		Left join A_Users u2 on IdUserB = u2.Id
	Where (( Viewed = 0 )
		and (IdUserB in ( Select id from @active )))
	Order by SentDate


	-- Считаем их просмотренными ?
	if ( @makeviewed = 1 ) begin

		Update m
		Set m.Viewed = 1
		From A_UserMessages m, @active u
		Where m.IdUserB = u.id and m.Viewed = 0	
	end
end
GO