﻿
---------------------------------------------
------- DISTR DIRECT Sync Table
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncTableP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTableP
GO

Create procedure A_TaskManager_List_DistrDirectDB_SyncTableP
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 200 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''	
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@table = 'dbo.T_X',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------


	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_executesql @sql
	end	
	

	-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog

	Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ' + @table + ' '' ) t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t 
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
			'

	-- обновляем на STATE = 3 удаленные из основной таблицы. (нужно только если количества не совпадают)

	Set @sql = @sql + '

			Declare @cnta int
			Select @cnta = Count ( * ) 
			From #tcache
		
			Declare @cntb int
			Select @cntb = Count ( Id )
			From ' + @tableidx + '

			if ( @cnta < @cntb ) begin
				Update tac with ( tablock ) 
				Set State = 3
				From ' + @tableidx + ' tac 
				Where not exists ( Select idc From #tcache Where [idc] = tac.[Id] )
					and ( State != 3 )
			end

			Drop table #tcache
			'

	exec sp_executesql @sql
end
GO

---------------------------------------------
------- DISTR DIRECT Sync Query
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncQueryP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQueryP
GO

Create procedure A_TaskManager_List_DistrDirectDB_SyncQueryP
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 200 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''	
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@query = 'Select * From dbo.T_X Where id < 2000',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_executesql @sql
	end	
	

	-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog

	Set @sql = '
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ( ' + @query + ' )a'') t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )				
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
			'

	
	-- обновляем на STATE = 3 удаленные из основной таблицы. (нужно только если количества не совпадают)

	Set @sql = @sql + '
			Declare @cnta int
			Select @cnta = Count ( * ) 
			From #tcache
		
			Declare @cntb int
			Select @cntb = Count ( Id )
			From ' + @tableidx + '
	
			if ( @cntb != @cnta ) begin
				Update t
				Set State = 3
				From ' + @tableidx + ' t
				Where not exists ( Select idc From #tcache Where idc = t.[Id] ) 
					and ( State != 3 )
			end

			Drop table #tcache
			'

	exec sp_executesql @sql
end
GO

-------------------------------------------------------------
------- DISTR DIRECT GET table
-------------------------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTableP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableP
GO

Create procedure A_TaskManager_List_DistrDirectDB_GetTableP
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@table = 'dbo.T_X',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )


	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_executesql @sql

		-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ' + @table + ' '' ) t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t 
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end

			Drop table #tcache
			'

		exec sp_executesql @sql
	end	
	
	

	-- берем значение минимального количества попыток по абонентам
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0 
		And IdOperator = ' + @operator + '
		'

	-- берем первый индекс с таким количеством попыток (по списку)
	-- и возвращаем его для организации запроса к исходной удаленной таблице
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select @id
		'

	-- Через времяночку индекс абонента получаем
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int )

	Insert into #tx ( id )
	    exec sp_executesql @sql

	Declare @id int
	Select @id = id
	From #tx
	
	Drop table #tx

	-- достаем из исходной таблицы строчку с указанным идентификатором	
	set @sql = '
		Select ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From ' + @table + 
			' Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'
	exec sp_executesql @sql

end

GO

---------------------------------------------
------- DISTR DIRECT GET query
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQueryP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryP
GO

Create procedure A_TaskManager_List_DistrDirectDB_GetQueryP
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@query = 'Select * From dbo.T_X Where id < 2000',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- cоздаем
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_executesql @sql
	

		-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ( ' + @query + ' )a'') t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )				
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
		
			Drop table #tcache
			'

	exec sp_executesql @sql
	end	
	
	

	-- берем значение минимального количества попыток по абонентам
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		And IdOperator = ' + @operator + '
		'
	-- берем первый индекс с таким количеством попыток (по списку)
	-- и возвращаем его для организации запроса к исходной удаленной таблице
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0	
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select @id
		'

	-- Через времяночку индекс абонента получаем
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int )

	Insert into #tx ( id )
	    exec sp_executesql @sql

	Declare @id int
	Select @id = id
	From #tx
	
	Drop table #tx
	
	-- достаем из исходной таблицы строчку с указанным идентификатором
	set @sql = '
		Select ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From (' + @query + ')a 
			Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'

	exec sp_executesql @sql
end
GO

---------------------------------------------
------- DISTR DIRECT GET EXACT table
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetTableExactP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetTableExactP
GO

Create procedure A_TaskManager_List_DistrDirectDB_GetTableExactP
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 50 ),
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@idinlist int,
	@number nvarchar(50),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@table = 'dbo.T_X',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@idinlist = 3,
	@number = '30002',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )


	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_executesql @sql

		-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ' + @table + ' '' ) t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t 
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end

			Drop table #tcache
			'

		exec sp_executesql @sql
	end	
	
	
	-- берем индекс, проверяя условия дополнительно (соответствия оператора и состояния)
	-- и возвращаем его для организации запроса к исходной удаленной таблице
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '
			--and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select @id
		'
	
	-- Через времяночку индекс абонента получаем
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int )

	Insert into #tx ( id )
	    exec sp_executesql @sql

	Declare @id int
	Select @id = id
	From #tx
	
	Drop table #tx

	-- достаем из исходной таблицы строчку с указанным идентификатором	
	set @sql = '
		Select ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From ' + @table + 
			' Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'
	exec sp_executesql @sql
end
GO

---------------------------------------------
------- DISTR DIRECT GET EXACT query 
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQueryExactP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExactP
GO


Create procedure A_TaskManager_List_DistrDirectDB_GetQueryExactP
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 200 ),
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@idinlist int,
	@number nvarchar(200),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@query = 'Select * From dbo.T_X Where id < 2000',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@idinlist = 3,
	@number = '30002',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- cоздаем
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_executesql @sql
	

		-- вставляем в цикле по 100000 записей чтобы не переполнить transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ( ' + @query + ' )a'') t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )				
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
		
			Drop table #tcache
			'

	exec sp_executesql @sql
	end	
	
	

	-- берем индекс, проверяя условия дополнительно (соответствия оператора и состояния)
	-- и возвращаем его для организации запроса к исходной удаленной таблице
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where State = 0
			and IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select @id
		'

	-- Через времяночку индекс абонента получаем
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int )

	Insert into #tx ( id )
	    exec sp_executesql @sql

	Declare @id int
	Select @id = id
	From #tx
	
	Drop table #tx
	
	-- достаем из исходной таблицы строчку с указанным идентификатором
	set @sql = '
		Select ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From (' + @query + ')a 
			Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'

	exec sp_executesql @sql
end
GO