﻿
if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Stat_Connection_SetVoiceParams' ))
	Drop procedure dbo.A_Stat_Connection_SetVoiceParams
GO

Create procedure dbo.A_Stat_Connection_SetVoiceParams
	@dtstart datetime,
	@alinenum nvarchar(10),
	@blinenum nvarchar(10),
	@avms int,
	@bvms int
as
begin
	Declare @idconn uniqueidentifier, @lensec int, @anum nvarchar(10), @bnum nvarchar(10)

	Select @idconn = Id, 
		@lensec = Abs ( cast ( TimeStop - TimeAnswer as float ) * 86400 ), 
		@anum = ALineNum, 
		@bnum = BLineNum
	From dbo.A_Stat_Connections_1x1 sc
	Where TimeStart = @dtstart
		And (( ALineNum = @alinenum And BLineNum = @blinenum ) or 
		     ( ALineNum = @blinenum And BLineNum = @alinenum ))

	if ( @@rowcount = 0 )
	    return

	Declare @ap int, @bp int, @as int, @bs int
	Select @ap = 0, @bp = 0, @as = 0, @bs = 0
	Select @ap = case when ( @avms + @bvms > 0 ) then @avms * 100 / ( @avms + @bvms ) else 0 end,
		@bp = case when ( @avms + @bvms > 0 ) then @bvms * 100 / ( @avms + @bvms ) else 0 end,
		@as = @avms / 1000,
		@bs = @bvms / 1000
	if ( @bvms > 0 )
		Set @bp = 100 - @ap

	if ( @anum = @alinenum )
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc, avsec, bvsec )
		Values ( @idconn, @lensec, @ap, @bp, @as, @bs )
	else
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc, avsec, bvsec )
		Values ( @idconn, @lensec, @bp, @ap, @bs, @as )
	
end
GO



if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Stat_Connection_GetVoiceParams' ))
	Drop procedure dbo.A_Stat_Connection_GetVoiceParams
GO

Create procedure dbo.A_Stat_Connection_GetVoiceParams
	@idconn uniqueidentifier
as
begin
	Select avperc, bvperc
	From A_Stat_Connections_VoicePerc
	Where idconn = @idconn
end
GO