﻿
If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_WorkPlaces' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_WorkPlaces' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_WorkPlaces
	Add [IsDynamicConfig] bit default 0
GO


Update oktell_settings.dbo.A_WorkPlaces
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO


IF  EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_WorkPlaces]'))
DROP VIEW [dbo].[A_WorkPlaces]
GO


Create VIEW [dbo].[A_WorkPlaces]
As
	Select *
	FROM oktell_settings.dbo.A_WorkPlaces
GO

-----------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_Phone' ))
	Drop procedure dbo.[A_DynamicConfig_Add_Phone]
GO

Create procedure [dbo].[A_DynamicConfig_Add_Phone]
	@phoneid uniqueidentifier,
	@type int = 5,
	@caption nvarchar(200) = '',	
	@linenumstr nvarchar(20) = '',
	@parentgroupid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@defuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@websockuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@address nvarchar(100) = '',
	@sipuser nvarchar(100) = '',
	@siplogin nvarchar(100) = '',
	@sippass nvarchar(100) = '',
	@linecode nvarchar(200) = '',
	@citystraight bit = 0,
	@busymode int = 1,	
	@translit int = -1,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin

	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	-- Сервер определяем
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = @empty )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = @empty )
		
	-- В линии
	Insert into A_ServerSipLines ( Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, Address, SipUser, SipLogin, SipPass, StreamId, BusyMode, LineCode, WebsockUserId, Translit, SystemNumStr, IsDynamicConfig )
	Values ( @phoneid, @type, @srvid, 0, 1, @caption, @citystraight, @parentgroupid, @defuserid, @address, @sipuser, @siplogin, @sippass, '00000000-0000-0000-0000-000000000000', @busymode, @linecode, @websockuserid, @translit, @linenumstr, 1)

	-- В рабочие места
	Declare @tableid uniqueidentifier
	Set @tableid = NEWID()
	
	Insert into A_WorkPlaces ( ID, Type, ParentID, Address, HasDatabase, HasExtLines, HasFastEngine, HasGSM, HasIntLines, HasLogic, name, LineID, SortIndex, IsDynamicConfig )
	Values ( @tableid, 0, @srvid, '', 0, 0, 0, 0, 0, 0, '', @empty, 9, 1 )

	Insert into A_WorkPlaces ( ID, Type, ParentID, Address, HasDatabase, HasExtLines, HasFastEngine, HasGSM, HasIntLines, HasLogic, name, LineID, SortIndex, IsDynamicConfig )
	Values ( @phoneid, 4, @tableid, @sipuser, 0, 0, 0, 0, 0, 0, '', @phoneid, 9, 1 )

	-- Гарантируем неповторяемость назначенных пользователей
	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
End
GO

---------------------------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Modify_Phone' ))
	Drop procedure dbo.[A_DynamicConfig_Modify_Phone]
GO

Create procedure [dbo].[A_DynamicConfig_Modify_Phone]
	@phoneid uniqueidentifier,
	@parentgroupid uniqueidentifier = null,
	@defuserid uniqueidentifier = null,
	@websockuserid uniqueidentifier = null,
	@address nvarchar(100) = null,
	@sipuser nvarchar(100) = null,
	@siplogin nvarchar(100) = null,
	@sippass nvarchar(100) = null,
	@linecode nvarchar(200) = null,
	@citystraight bit = null,
	@busymode int = null,
	@translit int = null
as
Begin

	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	-- Линии
	Update A_ServerSipLines
	Set 	
		ParentGroupId = IsNull ( @parentgroupid, ParentGroupId ),
		DefaultUserId = IsNull ( @defuserid, DefaultUserId ),
		WebSockUserId = IsNull ( @websockuserid, WebSockUserId ),
		Address = IsNull ( @address, Address ),
		SipUser = IsNull ( @sipuser, SipUser ),
		SipLogin = IsNull ( @siplogin, SipLogin ),
		SipPass = IsNull ( @sippass, SipPass ),
		LineCode = IsNull ( @linecode, LineCode ),
		BusyMode = IsNull ( @busymode, BusyMode ),
		CityStraight = IsNull ( @citystraight, CityStraight ),
		Translit = IsNull ( @translit, Translit )
	Where Id = @phoneid

	-- Рабочие места
	if ( @sipuser is not NULL )
		Update A_WorkPlaces
		Set Address = @sipuser
		Where id = @phoneid

	-- Гарантируем неповторяемость назначенных пользователей
	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
End
GO

-------------------------------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_Phone' ))
	Drop procedure dbo.[A_DynamicConfig_Remove_Phone]
GO

Create procedure [dbo].[A_DynamicConfig_Remove_Phone]
 	@phoneid uniqueidentifier
as
Begin
	-- Из линий
	Delete From A_ServerSipLines
	Where Id = @phoneid

	-- Из рабочих мест
	Declare @tableid uniqueidentifier
	Select @tableid = ParentId
	From A_WorkPlaces
	Where Id = @phoneid
		And IsDynamicConfig = 1

	Delete From A_WorkPlaces
	Where Id = @tableid
		and IsDynamicConfig = 1

	Delete From A_WorkPlaces
	Where Id = @phoneid
		and IsDynamicConfig = 1
End
GO

----------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Clear' ))
	Drop procedure dbo.[A_DynamicConfig_Clear]
GO

Create Procedure [dbo].[A_DynamicConfig_Clear] 
	@ext bit = 1,
	@int bit = 1
as
begin
	if ( @int = 1 ) begin

		Delete From A_ServerSipLines Where IsDynamicConfig = 1
	end

	if ( @ext = 1 ) begin
		
		Delete FROM A_ServerExtLines Where IsDynamicConfig = 1
		Delete FROM A_ServerGates Where IsDynamicConfig = 1
		Delete FROM A_ServerStreams Where IsDynamicConfig = 1
		Delete FROM A_CallRoutes Where IsDynamicConfig = 1	

		Delete From A_WorkPlaces Where IsDynamicConfig = 1

		Delete From A_CallRoutes_Lines Where not [idroute] in ( Select [ID] From A_CallRoutes )

	end
end
GO