﻿if exists ( SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UpdateDialogTrigger]'))
	DROP TRIGGER [dbo].[W_UpdateDialogTrigger]
GO

Create TRIGGER [dbo].[W_UpdateDialogTrigger] 
   ON [dbo].[A_UserMessageLink]
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	Declare @message nvarchar(4000), @count int
	
	-- NEW (by peter)
	Declare @tableinserted table 
	( 
		[Id] [uniqueidentifier] NOT NULL,
		[IdUserA] [uniqueidentifier] NULL,
		[IdUserB] [uniqueidentifier] NULL,
		[SentDate] [datetime] NOT NULL,
		[Message] [text] COLLATE database_default,
		[Viewed] [bit] NULL,
		[ViewedDate] [datetime] NULL,
		[IsConf] [int] NULL DEFAULT (0),
		[IdMessageData] int
    )

	Insert into @tableinserted ( id, idusera, iduserb, sentdate, message, viewed, vieweddate, isconf, idmessagedata )
		Select i.Id, umd.IdUserA, i.IdUserB, umd.SentDate, umd.Message, i.Viewed, i.ViewedDate, umd.IsConf, umd.Id
		From inserted i
			Inner join A_UserMessageData umd on umd.Id = i.IdMessageData

	-- Change from inserted to @tableinserted

	--------
	
	Declare @cnt int

	Select @cnt= count ( * ) 
	From @tableinserted
	Where IsConf = 0

	if ( @cnt = 0 )
  	  return;

		
	Select @message = substring (message, 0, 255)
	From @tableinserted
	
	Update W_Messages_Dialogs 
	Set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount+1,
		hasnew = 0,
		fromA = 1
	From @tableinserted i,
		W_Messages_Dialogs md
	Where md.iduserA = i.iduserA 
		and md.iduserB = i.iduserB
	
	
	
	if (( Select count(*) 
		  From @tableinserted i, A_UserMessageData umd, A_UserMessageLink uml
		  Where ( umd.Id = uml.IdMessageData ) 
				and umd.iduserA = i.iduserB 
				and uml.iduserB = i.iduserA 
				and uml.Viewed = 0) > 0)
	begin
		Update W_Messages_Dialogs 
		Set hasnew = 1 
		From @tableinserted i, W_Messages_Dialogs md 
		Where md.iduserA = i.iduserA 
			and md.iduserB = i.iduserB 
			and hasnew = 0
	end
	
	
	Update W_Messages_Dialogs 
	Set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount + 1,
		hasnew = 1,
		fromA = 0
	From @tableinserted i, 
		W_Messages_Dialogs md
	Where md.iduserB = i.iduserA 
		and md.iduserA = i.iduserB
	
	if ( @@rowcount = 0 ) begin
	
		Select @count = count (*)
		From @tableinserted i, A_UserMessageData umd, A_UserMessageLink uml
		Where ( umd.Id = uml.IdMessageData ) 
			and ((umd.iduserA = i.iduserA and uml.iduserB = i.iduserB) 
				or (uml.iduserB = i.iduserA and umd.iduserA = i.iduserB))
		
		Declare @conftimestart datetime
		Declare @confname nvarchar(250)
		Select @conftimestart = TimeStart, @confname = Name 
		From A_Stat_Conference sc, @tableinserted i 
		Where sc.Id = i.iduserA 
			or sc.Id = i.iduserB
		
		Insert into W_Messages_Dialogs (iduserA, iduserB, sentdate, messagecount, lastmessage, hasnew, conftimestart, confname)--
		  Select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			0,
			@conftimestart,
			@confname
		  From @tableinserted
		
		Insert into W_Messages_Dialogs (iduserB, iduserA, sentdate, messagecount, lastmessage, hasnew, conftimestart, confname)--
		  Select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			1,
			@conftimestart,
			@confname
		  From @tableinserted
	end
END
GO
