﻿-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_SessionStorage_GetAll' ))
	Drop procedure dbo.A_SessionStorage_GetAll
GO

Create procedure dbo.A_SessionStorage_GetAll
	@dbid int,
	@dtnow datetime = NULL
as
begin
	
	if ( @dtnow is NULL )
		Set @dtnow = GetDate()
	
	Select storeid, storeinterval, storedt, userid, remoteip
	From A_SessionStorage
	Where (storageid = @dbid)
		And (DateAdd ( ms, storeinterval, storedt ) > @dtnow)
		
end
GO

-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_SessionStorage_Save' ))
	Drop procedure dbo.A_SessionStorage_Save
GO

Create procedure dbo.A_SessionStorage_Save
	@dbid int,
	@storeid nvarchar(100),
	@storeinterval int,
	@storedt datetime,
	@userid uniqueidentifier,
	@remoteip nvarchar(50) = NULL
as
begin

	Update A_SessionStorage
	Set storeinterval = @storeinterval,
		storedt = @storedt,
		userid = @userid,
		remoteip = @remoteip
	Where (storageid = @dbid)
		And (storeid = @storeid)
	
	if ( @@rowcount = 0 ) begin
	
		Insert into A_SessionStorage ( storageid, storeid, storeinterval, storedt, userid, remoteip )
		Values ( @dbid, @storeid, @storeinterval, @storedt, @userid, @remoteip )
		
	end
	
end
GO


-----------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_SessionStorage_FilterSessions' ))
	Drop procedure dbo.A_SessionStorage_FilterSessions
GO

Create procedure dbo.A_SessionStorage_FilterSessions
	@dtnow datetime = null
as
begin
	
	if ( @dtnow is NULL )
		Set @dtnow = GetDate()
	
	Delete From A_SessionStorage
	Where (DateAdd ( ms, storeinterval, storedt ) < @dtnow)
	
end
GO