﻿-----------------------------------------------------------------------------	
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Dashboards_CheckCanEdit' ))
	Drop procedure dbo.A_Dashboards_CheckCanEdit
GO

Create procedure dbo.A_Dashboards_CheckCanEdit
	@authorizeduserid uniqueidentifier,
	@dashboardid uniqueidentifier,
	@canedit bit output	
as
begin
	-- Проверяет возможность редактирования дашборда пользователем

	-- По умолчанию запрещено
	Set @canedit = 0

	-- Проект какой у дашборда?
	Declare @projectid uniqueidentifier	
	--Select @projectid = d.IdProject
	--From [dbo].[WO_Dashboards_Dashboards] d	
	--Where d.Id = @dashboardid
	Select @projectid = o.IdParentProject
	From [dbo].[A_Policy_Objects] o
	Where o.Id = @dashboardid
			
	if (( not @projectid is NULL ) and ( @projectid != '00000000-0000-0000-0000-000000000000' )) begin
	
		/* Привилегия просмотра по проекту есть?
		*/
		Declare @rowcntp int
		
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @authorizeduserid,
			@idobject = @projectid,
			@idprivilege = 'F876E650-7972-475A-AE96-BCCF831AF818',
			@onlyreturncount = 1,
			@resultcount = @rowcntp OUTPUT
			
		-- Просмотр проекта запрещен, значит запрещено редактирование дашборда
		if ( @rowcntp = 0 )
			return
	end
	
	/* Привилегия изменения по дашборду есть?
	*/
	Declare @rowcntd int
	
	exec A_Policy_SubjectPrivileges_GetForUserByObject
		@iduser = @authorizeduserid,
		@idobject = @dashboardid,
		--@idprivilege = '95176304-7E76-46FE-A473-0DF01F29B863', --просмотр
		@idprivilege = 'C04D309A-159F-4F13-9C50-01B74945CAD5', --изменение
		@onlyreturncount = 1,
		@resultcount = @rowcntd OUTPUT
			
	-- Нет связки привилегии/объекта/юзера по совместному фильтру
	if ( @rowcntd = 0 )
		return
		
	Set @canedit = 1		
	
end
GO

-----------------------------------------------------------------------------	
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTailsOnStart' ))
	Drop procedure dbo.[A_DB_RemoveTailsOnStart]
GO

Create Procedure [dbo].[A_DB_RemoveTailsOnStart]
as
begin
		-- Заполняются описательные таблицы виджетов дашбордов
		exec dbo.WO_Dashboards_Widgets_Filters_Operation_Fill
		
		-- динамические объекты карты сети 
		exec dbo.A_DynamicConfig_Clear

		-- Регистрации 
		exec dbo.A_StreamRegistration_Clear
		
		-- Обновление кэша политики прав доступа к объектам
		exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
		
		
		-- Прочие хвосты
		exec dbo.A_DB_RemoveTails
end
GO