﻿

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists_old' ))
	Drop table oktell_settings.dbo.A_TaskManager_Lists_old
GO


use oktell_settings

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Lists' ))
	exec sp_rename 'dbo.A_TaskManager_Lists', 'A_TaskManager_Lists_old'
	
use oktell
GO


if not exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
CREATE TABLE oktell_settings.[dbo].[A_TaskManager_Lists]
(
	[Id] [uniqueidentifier] PRIMARY KEY NOT NULL,
	[Name] [nvarchar](100) NOT NULL,
	[Description] [nvarchar](255) NOT NULL,
	[ProjectId] [uniqueidentifier] NULL,
	[Type] [int] NOT NULL,
	[Query] [nvarchar](1000) NULL,
	[JoinedTable] [nvarchar](100) NULL,
	[ColumnId] [nvarchar](100) NULL,
	[ColumnsPhone] [nvarchar](1000) NULL,
	[ColumnName] [nvarchar](100) NULL,
	[ColumnOperator] [nvarchar](100) NULL,
	[ColumnSkillTags] [nvarchar](1000) NULL,
	[ColumnsViewed] [nvarchar](1000) NULL,
	[ColumnsViewedDescription] [nvarchar](4000) NULL,
	[ColumnsSqlType] [nvarchar](4000) NULL,
	[ColumnsSqlTypeSize] [nvarchar](4000) NULL,
	[GetViewedFromTable] [bit] NULL,
	[DbConnId] [int] NULL,
	[DbConnString] [nvarchar](1000) NULL,
	[DbConnMode] [int] NULL,
	[DbProviderName] [nvarchar](100) NULL, 
) ON [PRIMARY]
GO
	


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Lists' ))
	Drop view dbo.A_TaskManager_Lists
GO

Create view dbo.A_TaskManager_Lists
as 
	Select * 
	From oktell_settings.dbo.A_TaskManager_Lists
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists_old' ))
	Insert into oktell_settings.dbo.A_TaskManager_Lists 
	(   
		[Id],
		[Name],
		[Description],
		[ProjectId],
		[Type],
		[Query],
		[JoinedTable],
		[ColumnId],
		[ColumnsPhone],
		[ColumnName],
		[ColumnOperator],
		[ColumnSkillTags],
		[ColumnsViewed],
		[ColumnsViewedDescription],
		[ColumnsSqlType],
		[ColumnsSqlTypeSize],
		[GetViewedFromTable],
		[DbConnId],
		[DbConnString],
		[DbConnMode],
		[DbProviderName]
	 )
		Select [Id],
			[Name],
			[Description],
			[ProjectId],
			[Type],
			[Query],
			[JoinedTable],
			[ColumnId],
			[ColumnsPhone],
			[ColumnName],
			'',
			'',
			[ColumnsViewed],
			[ColumnsViewedDescription],
			[ColumnsSqlType],
			[ColumnsSqlTypeSize],
			[GetViewedFromTable],
			[DbConnId],
			[DbConnString],
			[DbConnMode],
			[DbProviderName]
		From oktell_settings.dbo.A_TaskManager_Lists_old
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists_old' ))
	Drop table oktell_settings.dbo.A_TaskManager_Lists_old
GO


-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_Save' ))
	Drop procedure dbo.[A_TaskManager_List_Save]
GO
	
Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnoperator nvarchar ( 100 ) = '',
	@columnskilltags nvarchar ( 1000 ) = '',
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 ),
	@dbconnid int = 0,
	@dbconnstring nvarchar(1000) = '',
	@dbconnmode int = 0,
	@dbprovidername nvarchar(100) = '',
	@iduser uniqueidentifier = NULL
as
begin
	-- Сохраняет данные о таблице абонентов
	
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	-- если это локальная таблица, и изменено ее имя
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		[Name]					= @name,
		[Description]			= @description,
		[ProjectId]				= @idproject,
		[Type]					= @type,
		[Query]					= @query,
		[JoinedTable]			= @joinedtable,
		[GetViewedFromTable]	= @getviewedfromtable,
		[ColumnId] 				= @columnid,
		[ColumnsPhone] 			= @columnsphone,
		[ColumnName] 			= @columnname,
		[ColumnOperator] 		= @columnoperator,
		[ColumnSkillTags] 		= @columnskilltags,
		[ColumnsViewed] 		= @columnsviewed,
		[ColumnsViewedDescription] = @columnsvieweddescription,
		[ColumnsSqlType] 		= @columnssqltype,
		[ColumnsSqlTypeSize] 	= @columnssqltypesize,
		[DbConnId]				= @dbconnid,
		[DbConnString]			= @dbconnstring,
		[DbConnMode]			= @dbconnmode,
		[DbProviderName]		= @dbprovidername
	Where Id = @id

	if ( @@rowcount = 0 ) begin

		-- Добавляется новый		
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnOperator, ColumnSkillTags, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize, DbConnId, DbConnString, DbConnMode, DbProviderName )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnoperator, @columnskilltags, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize, @dbconnid, @dbconnstring, @dbconnmode, @dbprovidername )
		
	end
		
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии
	   только если это не авто список для задач из IVR (признак - отсутствие привязки к проекту)
	*/
	if ( @idproject != '00000000-0000-0000-0000-000000000000' )
		exec A_Policy_Objects_Save
			@idObject = @id,
			@type = 107,
			@name = @name,
			@idParentProject = @idproject,
			@actionUserId = @iduser
end
GO


-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_GetInfo' ))
	Drop procedure dbo.[A_TaskManager_List_GetInfo]
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@idlist uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	-- Возвращает информацию о таблице абонентов по идентификатору
	
	Select t.[Id], t.[Name], t.[Description], t.[ProjectId], t.[Type], 
		t.[Query], t.[JoinedTable], t.[ColumnId], t.[ColumnsPhone], 
		t.[ColumnName], t.[ColumnsViewed], t.[ColumnsViewedDescription],
		t.[ColumnsSqlType], t.[ColumnsSqlTypeSize],
		t.[GetViewedFromTable],
		t.[DbConnId], t.[DbConnString], t.[DbConnMode], t.[DbProviderName],
		t.[ColumnOperator], t.[ColumnSkillTags]
	From A_TaskManager_Lists t
	Where t.[Id] = @idlist
	Order by t.[Name]
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_GetViewedByProject' ))
	Drop procedure dbo.[A_TaskManager_List_GetViewedByProject]
GO

Create procedure [dbo].[A_TaskManager_List_GetViewedByProject]
	@idproject uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	-- Возвращает информацию о всех таблицах абонентов, входящих в указанный проект
	
	-- Привилегии доступные пользователю по таблицам абонентов
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @iduser,
			@objecttype = 107
			--@idparentproject = NULL,
			--@idprivilege = '495DEB4D-D5FF-4C52-A219-541C3AEC6CAC'


	-- Таблицы абонентов
	Select t.[Id], t.[Name], t.[Description], t.[ProjectId], t.[Type], 
		t.[Query], t.[JoinedTable], t.[ColumnId], t.[ColumnsPhone], 
		t.[ColumnName], t.[ColumnsViewed], t.[ColumnsViewedDescription],
		t.[ColumnsSqlType], t.[ColumnsSqlTypeSize],
		t.[GetViewedFromTable],
		t.[DbConnId], t.[DbConnString], t.[DbConnMode], t.[DbProviderName],
		t.[ColumnOperator], t.[ColumnSkillTags]
	From (
			Select Distinct [Id]
			From A_TaskManager_Lists t
				Inner join #privileges p on p.[idObject] = t.[Id]
			Where t.[ProjectId] = @idproject
		) a
		Inner join A_TaskManager_Lists t on t.[Id] = a.[Id]
	Order By t.[Name]
	
	
	-- Набор привилегий для каждого из доступных индикаторов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO