﻿
USE [oktell_cc_temp]
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Cube_CC_OperatorStates_Old' ))
	Drop table dbo.A_Cube_CC_OperatorStates_Old
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Cube_CC_OperatorStates2' ))
	Drop table dbo.A_Cube_CC_OperatorStates2
GO

USE [oktell_cc_temp]
exec sp_rename [A_Cube_CC_OperatorStates], [A_Cube_CC_OperatorStates_Old]
GO


USE [oktell_cc_temp]
CREATE TABLE [dbo].[A_Cube_CC_OperatorStates](
	[Id] [bigint] IDENTITY(1,1) NOT NULL PRIMARY KEY,
	[IdTask] [uniqueidentifier] NULL,
	[IsOutput] [bit] NULL,
	[IdOperator] [uniqueidentifier] NOT NULL,
	[CallResult] [int] NULL,
	[State] [int] NOT NULL,
	[DateTimeStart] [datetime] NOT NULL,
	[DateStart] [datetime] NOT NULL,
	[TimeStart] [datetime] NOT NULL,
	[DateTimeStop] [datetime] NOT NULL,
	[LenTime] [float] NOT NULL,
	[ICode] [int] NULL,
	[IdEffort] [uniqueidentifier] NULL,
) ON [PRIMARY]
GO


exec sp_rename [A_Cube_CC_OperatorStates], [A_Cube_CC_OperatorStates2]
GO

exec sp_rename [A_Cube_CC_OperatorStates_Old], [A_Cube_CC_OperatorStates]
GO

USE [oktell_cc_temp]
Set Identity_Insert dbo.A_Cube_CC_OperatorStates Off
Set Identity_Insert dbo.A_Cube_CC_OperatorStates2 On

Declare @k int, @max bigint
Select @k = 1, @max = 0

While ( @k > 0 ) begin

	Insert into dbo.A_Cube_CC_OperatorStates2
	( Id, IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode, IdEffort )
		Select Top 10000
			 Id, IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode, IdEffort
		From dbo.A_Cube_CC_OperatorStates t
		Where Id > @max
		Order by Id
		
	if ( @@rowcount = 0 )
		Set @k = 0	
			
	Select @max = Max(Id)
	From dbo.A_Cube_CC_OperatorStates2	
	
end
	
Set Identity_Insert dbo.A_Cube_CC_OperatorStates2 Off
GO

USE [oktell_cc_temp]
exec sp_rename [A_Cube_CC_OperatorStates], [A_Cube_CC_OperatorStates_Old]
GO

USE [oktell_cc_temp]
exec sp_rename [A_Cube_CC_OperatorStates2], [A_Cube_CC_OperatorStates]
GO

USE [oktell_cc_temp]

	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStart' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateTimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DTStart' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DTStart ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateStart,
		TimeStart
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_DateTimeStop' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_DateTimeStop ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		DateTimeStop
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdOperator' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdOperator ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		IdOperator
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_IdTask' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_IdTask ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		IdTask
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_CallResult' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_CallResult ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		CallResult
	) WITH FILLFACTOR = 80


	if not exists ( select name from oktell_cc_temp..sysindexes where id=object_id('oktell_cc_temp.dbo.A_Cube_CC_OperatorStates') and name = 'idxCubeOperatorStates_State' )
	CREATE NONCLUSTERED INDEX idxCubeOperatorStates_State ON oktell_cc_temp.dbo.A_Cube_CC_OperatorStates
	(
		State
	) WITH FILLFACTOR = 80


    if not exists ( select * from oktell_cc_temp.dbo.sysindexes where name = N'idxCubeOperatorStates_IdEffort_IdOperator' and id = object_id(N'oktell_cc_temp.[dbo].[A_Cube_CC_OperatorStates]'))
	CREATE NONCLUSTERED INDEX [idxCubeOperatorStates_IdEffort_IdOperator] ON oktell_cc_temp.[dbo].[A_Cube_CC_OperatorStates]
	(
	   [IdEffort], [IdOperator]
	) WITH  FILLFACTOR = 80
GO

USE [oktell_cc_temp]
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Cube_CC_OperatorStates_Old' ))
	Drop table dbo.A_Cube_CC_OperatorStates_Old
GO

USE [oktell]
GO

