﻿if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserGroup_User_Save' ))
	Drop procedure dbo.A_Admin_UserGroup_User_Save
GO
	
Create procedure [dbo].[A_Admin_UserGroup_User_Save]
	@id		uniqueidentifier,
	@name		nvarchar ( 200 ),
	@info		nvarchar ( 1000 ),
	@parentgroupid	uniqueidentifier,
	@login		nvarchar ( 50 ),
	@password	nvarchar ( 50 ),	
	@type		int,
	@isoperator	bit,
	@roleid		uniqueidentifier = null,
	@callerid	nvarchar ( 20 ) = '',
	@isdeleted	bit = 0,
	@deletedt	datetime = NULL
as
begin

	Declare @deletedtN DateTime
	Select @deletedtN = case when (( @isdeleted is null ) or ( @isdeleted = 0 )) then NULL else @deletedt end

	Update A_Users
	Set 	
		Name 		= @name,
		Info 		= @info,
		ParentGroupId 	= @parentgroupid,
		Login		= @login,
		Password 	= @password,
		Type		= @type,
		IsDeleted	= @isdeleted,
		DeleteDT	= @deletedtN
	Where 
		Id = @id
	
	if ( @@rowcount = 0 ) begin
		
		-- Добавление нового пользователя
		Insert Into A_Users ( Id, Name, Info, ParentGroupId, Login, Password, Type, Enabled, IsDeleted, DeleteDT )
		Values ( @id, @name, @info, @parentgroupid, @login, @password, @type, 1, @isdeleted, @deletedt )
			
		-- Заказ на пересчет кэша политики доступа
		exec A_Policy_SubjectGroupCache_SetUpdate
		
	end


	Update A_UserParams
	Set	IdRole = @roleid,
		CallerId = @callerid,
		IsOperator = @isoperator
	Where IdUser = @id

	if ( @@rowcount = 0 ) begin
		Insert 
		Into A_UserParams ( IdUser, IdRole, IsOperator, CallerId, IsRedirect, IsCC, IsLunch  )
		Values	( @id, @roleid, @isoperator, @callerid, 0, 0, 0 )
	end


	exec A_Admin_UserGroup_Group_SiftEmpty


	-- в базе кубов поправляем имя юзера
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo
		Set Name = @name
		Where Id = @id

end
GO