﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_GetDataForUser' ))
	Drop procedure dbo.A_VoiceMail_GetDataForUser
GO

Create procedure [dbo].[A_VoiceMail_GetDataForUser]
	@userid			uniqueidentifier,
	@onlynew		int = 1,
	@topcount		int = -1,
	@vmid			uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin

	if ( @vmid = '00000000-0000-0000-0000-000000000000' ) begin
	
		Declare @tmp table ( idx int identity ( 1, 1 ), Id uniqueidentifier, SentTime datetime )

		Insert into @tmp
			Select vm.Id, SentTime
	    		From A_VoiceMail vm
				Left join A_VoiceMailReceivers vmr on vmr.MsgId = vm.id
	    		Where ((( vm.RecieverIsGroup = 0 ) And ( vm.RecieverId = @userid ))
					Or (( vm.RecieverIsGroup = 1 ) And ( vmr.UserId = @userid )))
				And (( IsShown = 0 ) or ( @onlynew = 0 ))
			Order by SentTime

			

		if ( @topcount <= 0 ) begin

			Select vm.Id, vm.FilePath, vm.IsShown, vm.SentTime, vm.RecievedTime, vm.Info, vm.CallerId, vm.WhoRecieved, u.Name 
			From @tmp t
				Inner join A_VoiceMail vm on vm.id = t.id
				left join A_Users u on vm.WhoRecieved = u.Id

		end else begin

			Select vm.Id, vm.FilePath, vm.IsShown, vm.SentTime, vm.RecievedTime, vm.Info, vm.CallerId, vm.WhoRecieved, u.Name 
			From @tmp t
				Inner join A_VoiceMail vm on vm.id = t.id
				left join A_Users u on vm.WhoRecieved = u.Id
			Where t.idx <= @topcount

		end
		
	end else begin
	
		Select vm.Id, vm.FilePath, vm.IsShown, vm.SentTime, vm.RecievedTime, vm.Info, vm.CallerId, vm.WhoRecieved, IsNull ( u1.Name, u2.Name ) as UserName
	    From A_VoiceMail vm
				Left join A_VoiceMailReceivers vmr on vmr.MsgId = vm.id
				Left join A_Users u1 on vm.WhoRecieved = u1.Id
				Left join A_Users u2 on vmr.UserId = u2.Id
	    Where ((( vm.RecieverIsGroup = 0 ) And ( vm.RecieverId = @userid ))
				Or (( vm.RecieverIsGroup = 1 ) And ( vmr.UserId = @userid )))
				And ( vm.Id = @vmid )
				
	
	end
	
end
GO