﻿if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_LangText_Multi' ))
	Drop table dbo.A_LangText_Multi
GO

Create table dbo.A_LangText_Multi 
( 
	langkey nvarchar(400) Collate database_default not null,
	langval nvarchar(1000) Collate database_default not null,
	langcode nvarchar(3) Collate database_default not null 
)
GO

Create index idx_LangText_Multi_keycode on dbo.A_LangText_Multi ( langcode, langkey ) 
GO

----------------
if (object_id ( 'dbo.A_LangText_Multi_Save' ) is not null )
	Drop procedure dbo.A_LangText_Multi_Save
GO

Create procedure dbo.A_LangText_Multi_Save
	@xml ntext
as
begin
	
	if (@xml is NULL)
		return
  
    If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml	
	Create table #tmp_xml 
	( 
		langkey nvarchar(400) Collate database_default not null,
		langval nvarchar(1000) Collate database_default not null,
		langcode nvarchar(3) Collate database_default not null 
	)
		
	Declare @idoc int
	Exec sp_xml_preparedocument @idoc OUTPUT, @xml
	
	Insert into #tmp_xml
		Select *
		From OpenXml (@idoc, '/items/l', 2)	
		With ( 
			langkey varchar(50) '@k',
			langval nvarchar(1000) '@v',
			langcode nvarchar(3) '@l'
		)	
		
				
	-- Удаляем тех, что нет в обновлении
	Delete
	From dbo.A_LangText_Multi
	Where not exists( Select 1 
						From #tmp_xml x 
						Where (dbo.A_LangText_Multi.langcode = x.langcode)
							and (dbo.A_LangText_Multi.langkey = x.langkey))
	
	-- Обновляем тех, что есть и там и там и у которых значение изменилось
	Update w
	Set w.langval = x.langval
	From dbo.A_LangText_Multi w, #tmp_xml x
	Where (w.langcode = x.langcode)
		and (w.langkey = x.langkey)
		and (w.langval != x.langval)
		
	-- Добавляем тех, что есть только в обновлении
	Insert into dbo.A_LangText_Multi (langkey, langval, langcode)
		Select Distinct x.langkey, x.langval, x.langcode
		From #tmp_xml x
		Where not exists ( Select 1 
							From dbo.A_LangText_Multi w 
							Where (w.langcode = x.langcode)
								and (w.langkey = x.langkey))
			
end
GO	

