﻿if ( not object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) is NULL )
	Drop procedure dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO

Create procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@timeexit datetime = NULL,--16.09.2010 выход из задачи, а то неявными способами определяет границу конца и ошибается на входящей IVR задаче без выхода.
	@idextline uniqueidentifier,
	@userresult int = 0,
	@idoperator uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@isattached bit = 0,
	@dtnow datetime = null
	
as 
begin	
	
/*	----------------------------------------
	Declare @idchain uniqueidentifier
	Declare @ideffort uniqueidentifier
	Declare @idinlist int
	Declare @idtask uniqueidentifier
	Declare @number nvarchar ( 20 )
	Declare @callresult int
	Declare @callresultinfo nvarchar ( 100 )
	Declare @lenqueue int
	Declare @timestart datetime
	Declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = 'Номер не определен', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/
	if ( @dtnow is null )
		set @dtnow = GetDate()

	-- выясняем направление и проект
	Declare @idproject uniqueidentifier,
            @isoutput bit,
            @idlist uniqueidentifier

	Select 	@idproject = IdProject,
		@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks 
	Where Id = @idtask

	-------------------------------------------------------------
	---- КУБ КОММУТАЦИЙ И ПОПЫТОК -------------------------------
	-------------------------------------------------------------

	if object_id ( 'tempdb..#temp' ) IS NOT NULL
		Drop table #temp

	-- создаем времянку
	--Declare @temp table 
	Create table #temp 
	( 
		[IdProject] uniqueidentifier,
		[IdTask] uniqueidentifier,
		[IsOutput] bit,
		[IdEffort] uniqueidentifier,
		[IdOperator] uniqueidentifier,
		[IdInList] int,
		[AbonentNumber] nvarchar ( 20 ) collate database_default,
		[CallResult] int,
		[CallResultInfo] nvarchar ( 100 ) collate database_default,
		[DateTimeStart] DateTime,
		[DateStart] DateTime,
		[TimeStart] DateTime,
		[DateTimeStop] DateTime,
		[IdConn] uniqueidentifier,
		[IdChain] uniqueidentifier,
		[IdAUser] uniqueidentifier,
		[IdBUser] uniqueidentifier,
		[IdExtLine] uniqueidentifier,
		[LenTime] float, 
		[LenQueue] float,
		[IsBetweenOp] bit,
		[OpponentInfo] nvarchar ( 100 ) collate database_default,
		[IsHandled] bit,
		[IsSuccess] bit,
		[IsRecorded] bit,
		[IdRecDir] int,
		[ALineNum] nvarchar ( 12 ) collate database_default,
		[BLineNum] nvarchar ( 12 ) collate database_default,
		[UserResult] int default 0
	)

 	--Create Index [#xx] ON #temp ([IdAUser], [IdBUser]) -- нужен ли??
	

	-- Declare @idempty uniqueidentifier -- используется только в 1ом месте 
	--Set @idempty = '00000000-0000-0000-0000-000000000000'

	Declare @idop uniqueidentifier
	Set @idop = nullif(@idoperator,'00000000-0000-0000-0000-000000000000')


	--Alex 101118
	Declare @idch uniqueidentifier
	set @idch = @idchain

	if ( not @callresult in (6, 7, 20, 13) ) -- оператора в пустышку заносим в случае отклонения и/или пропуска вызова оператором -- или 13 :)
	    Select @idop = NULL, @idch= NULL	--Alex 101118

    if exists ( Select 1 
				From A_Stat_Connections_1x1 With ( Index ( idx_StatConnections_IdChain ), NoLock ) 
				Where IdChain = @idchain ) begin
				
			-- вставляем коммутации во времянку (0, 1)
            Insert Into #temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, 
						CallResult, CallResultInfo, 
						DateTimeStart, DateStart, TimeStart, DateTimeStop, 
                        IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, 
                        IsRecorded, IdRecDir, ALineNum, BLineNum, UserResult ) --ARecFile, BRecFile )
				Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, 
					@callresult, @callresultinfo, 
					TimeStart, 
					Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
					Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( IsNull ( TimeStart, @dtnow ) as Float ) ) as DateTime ),
					IsNull ( TimeStop, @dtnow ),		
					Id, IdChain, AUserId, BUserId, 
					@idextline,
					Cast ( ( IsNull ( TimeStop, @dtnow ) - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
					IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile
					@userresult
				From A_Stat_Connections_1x1 c With ( INDEX ( idx_StatConnections_IdChain ), NOLOCK )
				Where (IdChain = @idchain)				
					-- удаляем записи по времени не пересекающиеся с попыткой
					-- Присоединение к звонку происходит посередине. Поэтому малость изменений
					and not ((Coalesce(TimeStop, @dtnow) <= @timestart) 
								or ((@isattached = 1) -- Но IVR тоже тем не менее удаляем по старому
									and (TimeStart < @timestart)
									and ((AUserId = 'AB000000-0000-0000-0000-000000000000' ) 
										or ( BUserId = 'AB000000-0000-0000-0000-000000000000' ))))
                      
            Declare @timeendeff datetime
            Set @timeendeff = Coalesce((Select min ( DateTimeStart ) From #temp), @timeexit)

            if ( @timeendeff < @timestart )
                Set @timestart = @timeendeff

            -- Пустышку добавим для общности, потом исключится если не нужна
            Insert Into #temp 
            ( 	IdProject, IdTask, IsOutput, IdEffort, 
                IdOperator, 
                IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateTimeStop,
                DateStart, 
                TimeStart,                 
                IdChain,	--Alex 101118
                --IdConn, IdAUser, IdBUser, 
                IdExtLine, LenTime, LenQueue, 
                --IsBetweenOp, 
                IsHandled, IsSuccess,
                --IsRecorded, IdRecDir, ARecFile, BRecFile 
                UserResult, OpponentInfo
            )
            Values 
            ( 	@idproject, @idtask, @isoutput, @ideffort, 
                @idop, 
                @idinlist, @number, @callresult, @callresultinfo, @timestart, @timeendeff,
                Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
                Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ),                 
                @idch,   --@idchain,  --Alex 101118
                --@idempty, @idempty, @idempty, 
                @idextline, 
                Cast ( @timeendeff - @timestart as float ) * 86400,
                @lenqueue, 
                --0, 
                0, 0,
                --0, 0, '', '',
                @userresult, ''
            )
            
            Declare @ivrid uniqueidentifier,
					@rowcount int
			Select @ivrid = 'AB000000-0000-0000-0000-000000000000',
				@rowcount = Count (*) 
			From #temp t 
			Where DateTimeStart >= @timestart
		
            Update t
            Set IsBetweenOp = Case when (((a_user.id is not NULL) or (t.IdAuser = @ivrid))
										and ((b_user.id is not NULL) or (t.IdBuser = @ivrid)))
                                   then 1
                                   else 0
                              end,
                IdOperator = Case when (((a_user.id is NULL) and (t.IdAuser is NULL))
										and ((b_user.id is NULL) and (t.IdBuser is NULL)))
									then IdOperator
								  when ((@isoutput > 0)
										or (((a_user.id is not NULL) or (t.IdAuser = @ivrid))
											and ((b_user.id is not NULL) or (t.IdBuser = @ivrid))))
								    then IdAUser
								  else IdBUser
							 end,
                ---- Обработан? ---------
                IsHandled = Case when (@rowcount > 1) then 1 else 0 end, --одна попытка всегда есть 
                 ---- Успешно? (5) ---------
                IsSuccess = Case when (@callresult = 5) then 1 else 0 end
            From #temp t
				Left join A_Users a_user On t.IdAUser = a_user.id 
				Left join A_Users b_user On t.IdBUser = b_user.id
            
            /*
            Update t
            Set -- вызов обработан? (4)--------------------------------
                  IsHandled = case when (Select Count (*) FROM #temp t Where DateTimeStart >= @timestart) > 1 then 1 else 0 end --одна попытка всегда есть
                 -- успешно ? (5)---------------------------------------
                , IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
            From #temp t
            
            */
    end else begin
    
            -- если эта попытка без коммутаций ?
            Declare @dtendeff DateTime
            Set @dtendeff = COALESCE(@timeexit,@dtnow)
            
            Insert Into #temp 
            ( 	IdProject, IdTask, IsOutput, IdEffort, 
                IdOperator, 
                IdInList, AbonentNumber, CallResult, CallResultInfo, 
                DateTimeStart, DateTimeStop,
                DateStart, 
                TimeStart,                 
                IdChain, 
                --IdConn, IdAUser, IdBUser, 
                IdExtLine, LenTime, LenQueue, 
                --IsBetweenOp, 
                IsHandled, IsSuccess,
                --IsRecorded, IdRecDir, ARecFile, BRecFile,
                UserResult, OpponentInfo
            )
            Values 
            ( 	@idproject, @idtask, @isoutput, @ideffort, 
                @idop, 
                @idinlist, @number, @callresult, @callresultinfo, 
                @timestart, @dtendeff,
                Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
                Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), 
                @idchain,
                --@idempty, @idempty, @idempty, 
                @idextline, 
                Cast ( @dtnow - @timestart as float ) * 86400,
                @lenqueue, 
                --0, 
                0, 0,
                --0, 0, '', '',
                @userresult, ''
            )
            --if ( @idoperator != '00000000-0000-0000-0000-000000000000' )
            --    Update #temp
            --    Set IdOperator = @idoperator
	END   
/*
	-- информация по абоненту (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From #temp t

	-- выдираем те, которые относятся к куску цепочки, принадлежащему данной задаче (необходимо при переключениях из задачи в задачу)
	if OBJECT_ID('tempdb..#textract') IS NULL
		drop table #textract
        
	Select * into #textract 
	    From #temp 
*/
/*
	if ( @isoutput = 0 ) -- вырезаем свой кусок если задача входящая и флаг соответствующий передан
	begin
		Declare @dt1 datetime, @dt2 datetime
		--своя начальная
		Select @dt1 = Max ( DateTimeStart ) From #textract Where DateTimeStart <= @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))
		--несвоя начальная
		Select @dt2 = Min ( DateTimeStart ) From #textract Where DateTimeStart > @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))

		if ( not @dt2 is null )--28.03.2008 for special callresults
			Delete from #textract Where DateTimeStart < @dt1 or DateTimeStart >= @dt2 or LenTime is NULL
	end
*/
	IF ( @timeexit is not NULL ) begin	
		IF EXISTS(SELECT 1 FROM #temp Where DateTimeStart > @timeexit or LenTime is NULL) 
			Delete 
			From #temp 
			Where (DateTimeStart > @timeexit)
				or (LenTime is NULL)
	end

	-- поля которые могли остаться нуллами замещаем на дефолтовые значения
	Update #temp
	Set LenTime = COALESCE(LenTime,0),
        DateTimeStop = COALESCE(DateTimeStop,DateTimeStart)
	
	-- обновляем LastConnected (чтоб не по кубу менеджер задач шнырил)
	if ( @idinlist >= 0 ) begin
		
		Declare @lc_maxdt DateTime

		Select @lc_maxdt = Max ( DateTimeStart ) 
		From #temp
		Where IdOperator != '00000000-0000-0000-0000-000000000000' 
			and IdOperator != 'AB000000-0000-0000-0000-000000000000'
			and IsHandled = 1

		if ( not @lc_maxdt is null ) begin
		
			Declare @lc_idoperator uniqueidentifier

			Select @lc_idoperator = IdOperator
			From #temp
			Where IdOperator != '00000000-0000-0000-0000-000000000000' 
				and IdOperator != 'AB000000-0000-0000-0000-000000000000'
				and IsHandled = 1
				and DateTimeStart = @lc_maxdt

			exec A_CallCenter_OperatorLastConnected_Set @lc_maxdt, @idproject, @idtask, @idlist, @idinlist, @number, @lc_idoperator
		end
	end


	-- обновляем куб Tmp_A_Cube_CC_EffortConnections ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[Tmp_A_Cube_CC_EffortConnections] With ( TabLock )
        Select * FROM #temp

	--Информация по задачам в таблицу категорий A_Cube_CC_Cat_Task
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name,Type, Isoutputtask From A_TaskManager_Tasks Where Id = @idtask	

	--Информация по проектам в таблицу категорий A_Cube_CC_Cat_Project
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	---- КУБ СОСТОЯНИЙ ОПЕРАТОРОВ -------------------------------
	-------------------------------------------------------------
	-- обновляется по таймеру из DBProvider

end
GO