﻿if not ( object_id ( 'dbo.W_Stat_MyCalls_Get' ) is null )
	Drop procedure dbo.W_Stat_MyCalls_Get
GO

Create procedure [dbo].[W_Stat_MyCalls_Get]
	@media 		int, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int, --1 - входящий, 2 - исходящий, 3 - пропущенный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@authorizeduserid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	@first int= NULL,
	@count int= NULL
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @authorizeduserid uniqueidentifier, @comment 	nvarchar ( 4000 ),@showivr bit, @first int,@count int

--set dateformat ymd
--select @media = 0,@type = 0,
--	@authorizeduserid='64f1a6ea-3f07-4b42-8cad-19eb9e1b97cd',
--	@dstart = '2012-05-21',@dstop = '2012-05-21 23:59:59',
--	@number = '', 
--	@comment = '', @showivr=0,@first = 0,@count = 140

	create table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					TimeAnswer DateTime, 
					TimeStop DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					IsRecorded int, 
					IdRecDir int, 
					ALineNum nvarchar ( 10 ) collate database_default, 
					BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier, 
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 200 ) collate database_default, 
					IsConf int, Director uniqueidentifier, 
					CTS DateTime,
					idclient uniqueidentifier
			
	)

	     
	declare @filtercomment bit
	set @filtercomment =  0 

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )
	Select sc.Id, 
			sc.IdChain,
			null, 
			0, 
			sc.TimeStart, 
			sc.TimeAnswer, 
			sc.TimeStop, 
			sc.TimeStop - sc.TimeAnswer as Length, 
			'', 
			'', 
			IsRecorded, 
			IdRecDir, 
			ALineNum, 
			BLineNum, --ARecFile, BRecFile, 
			AUserId, 
			BUserId, 
			ALineId, 
			BLineId, 
			AOutNumber, 
			BOutNumber, 
			AStr, 
			BStr,
			0 as IsConf, 
			@id0 as Director, 
			sc.TimeStart as CTS
	From A_Stat_Connections_1x1 sc --with ( TabLock )
	Where sc.TimeStop is not null and
				TimeStart >= @dstart 
				and TimeStart < @dstop
				and (AUserId = @authorizeduserid  or  BUserId = @authorizeduserid)
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	--Order By TimeStart Desc

	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

	Select Idg, IdChain, 3, 3, 
	TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
	AOutNumber, AStr, 0, 0, 
	ALineNum, BLineNum, 
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number,
	AStr, '',
	0, @id0, TimeStart
	From A_Stat_MissedCalls
	Where ( BUserId = @authorizeduserid )
	And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
   
    Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		    Select IdConn, 
			IdChain, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
			scc.TimeStart, 
			scc.TimeStart as TimeAnswer, 
			scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			 0,--case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, 
			LineNum, 
			sc.Room, 
			scc.IdUser, 
			@idconfuser,
			scc.IdLine, 
			IdConf,
			'', 
			'', 
			StrName, 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, 
			Director, 
			sc.TimeStart as CTS
			
		FROM A_Stat_Conference_Competitors scc	
			Inner join A_Stat_Conference sc with (index (idx_StatConf_IDConf))
			on sc.Id = scc.IdConf
			--Left join @A_Stat_Conference_tmp2 sct 
			--on sc.Id = sct.Id --фильтр по правам на прослушивание
		
		where  scc.TimeStart between @dstart and @dstop 
			and scc.IdUser = @authorizeduserid
 
	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @authorizeduserid and o.BUserId = u.Id ) or ( o.BUserId = @authorizeduserid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name, idclient = c.Id
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		--and ( c.OwnerId = @authorizeduserid )

	--Update o
	--Set o.AbonentName = c.Name
	--From #output o, A_Clients c, A_ClientContacts cc
	--Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
	--	and ( c.OwnerId = @id0 )
	--	and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From #output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	--select  isnull(max (rownumber),0) 
	--from #output
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
	(
		TimeStart deSC
	) WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select			rownumber = identity(int,1,1),
					sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart, 
					--TimeAnswer, 
					--TimeStop, 
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					--ALineId, 
					--BLineId, 
					--ALineNum, 
					--BLineNum, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName, 
					IsRecorded, 
					IdRecDir, 
					IsConf, 
					Director, 
					CTS, 
					case When ( c.Id is null ) then 0 else 1 end as HasComment	,
					idclient
					into #out	
	From #output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where (( Media = @media ) or ( @media = 0 ) or ( Type >= 10 ))
	Order By TimeStart Desc
	
	Select * 
	From #out
	Where rownumber between @first and @first + @count-1	

	Drop table #out
	Drop table #output

end
GO



if not ( object_id ( 'dbo.W_Stat_MyCalls_GetAll' ) is null )
	Drop procedure dbo.W_Stat_MyCalls_GetAll
GO

Create procedure [dbo].[W_Stat_MyCalls_GetAll]
	@media 		int, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int, --1 - входящий, 2 - исходящий, 3 - пропущенный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	@first int= NULL,
	@count int= NULL
as
begin
--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @userid uniqueidentifier, @comment 	nvarchar ( 4000 ),@showivr bit, @first int,@count int

--set dateformat ymd
--set @media = 0
--set @type = 0
--set @dstart = '2011-11-01'
--set @dstop = '2011-12-06'
--set @number = ''
--select @userid = '7a6c312a-0028-4007-beee-e73f93f9cb96'	, @comment = '', @showivr=0,@first = 10,@count = 140
	




	create table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					TimeAnswer DateTime, 
					TimeStop DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					IsRecorded int, 
					IdRecDir int, 
					ALineNum nvarchar ( 10 ) collate database_default, 
					BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier, 
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 200 ) collate database_default, 
					IsConf int, Director uniqueidentifier, 
					CTS DateTime
			
	)

     
	Declare @filtercomment bit
	Set @filtercomment =  0 

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

	Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )
			
		Select sc.Id, 
				sc.IdChain,
				null, 
				0, 
				sc.TimeStart, 
				sc.TimeAnswer, 
				sc.TimeStop, 
				sc.TimeStop - sc.TimeAnswer as Length, 
				'', 
				'', 
				IsRecorded, 
				IdRecDir, 
				ALineNum, 
				BLineNum, --ARecFile, BRecFile, 
				AUserId, 
				BUserId, 
				ALineId, 
				BLineId, 
				AOutNumber, 
				BOutNumber, 
				AStr, 
				BStr,
				0 as IsConf, 
				@id0 as Director, 
				sc.TimeStart as CTS
		From A_Stat_Connections_1x1 sc --with ( TabLock )
		Where sc.TimeStop is not null and
					TimeStart >= @dstart 
					and TimeStart < @dstop
					and (AUserId = @userid  or  BUserId = @userid)
					and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		--Order By TimeStart Desc

	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		Select Idg, IdChain, 3, 3, 
			TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
			AOutNumber, AStr, 0, 0, 
			ALineNum, BLineNum, 
			AUserId, BUserId,
			ALineId, BLineId,
			AOutNumber, Number,
			AStr, '',
			0, @id0, TimeStart
		From A_Stat_MissedCalls
		Where ( BUserId = @userid )
			And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
    Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'


	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		    Select IdConn, 
				IdChain, 
				case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
				case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
				scc.TimeStart, 
				scc.TimeStart as TimeAnswer, 
				scc.TimeStop, 
				scc.TimeStop - scc.TimeStart as Length, 
				'', 
				case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
				 0,--case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
				sc.IdRecDir, 
				LineNum, 
				sc.Room, 
				scc.IdUser, 
				@idconfuser,
				scc.IdLine, 
				IdConf,
				'', 
				'', 
				StrName, 
				case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
				1 as IsConf, 
				Director, 
				sc.TimeStart as CTS
			
			FROM A_Stat_Conference_Competitors scc	
				Inner join A_Stat_Conference sc with (index (idx_StatConf_IDConf))
				on sc.Id = scc.IdConf
				--Left join @A_Stat_Conference_tmp2 sct 
				--on sc.Id = sct.Id --фильтр по правам на прослушивание
			
			where  scc.TimeStart between @dstart and @dstop 
				and scc.IdUser = @userid
    

	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @userid )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @id0 )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From #output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	--select  isnull(max (rownumber),0) 
	--from #output
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
	(
		TimeStart deSC
	) WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select			rownumber = identity(int,1,1),
					sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart, 
					--TimeAnswer, 
					--TimeStop, 
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					--ALineId, 
					--BLineId, 
					--ALineNum, 
					--BLineNum, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName, 
					IsRecorded, 
					IdRecDir, 
					IsConf, 
					Director, 
					CTS, 
					case When ( c.Id is null ) then 0 else 1 end as HasComment	
					into #out	
	From #output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where (( Media = @media ) or ( @media = 0 ) or ( Type >= 10 ))
	Order By TimeStart Desc
	
	Select * 
	From #out
	Where rownumber between @first and @first + @count-1	
	
	Drop table #out
	Drop table #output
	
end
GO


if not ( object_id ( 'dbo.W_Stat_MyCalls_Relative' ) is null )
	Drop procedure dbo.W_Stat_MyCalls_Relative
GO


Create procedure [dbo].[W_Stat_MyCalls_Relative]
	@authorizeduserid 	uniqueidentifier,
	@abonent uniqueidentifier ,
	@number nvarchar ( 50 )
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
--declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @authorizeduserid uniqueidentifier,  @abonent uniqueidentifier 

--set dateformat ymd
--set @media = 0
--set @type = 0
--set @dstart = '2011-11-01'
--set @dstop = '2011-12-06'
--set @number = ''
--select @authorizeduserid = '7a6c312a-0028-4007-beee-e73f93f9cb96'	, 
--	@abonent = 'CE293C6A-E748-45D9-8DC1-ED1E34B759FC'

	create table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier,
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 200 ) collate database_default
	)
     
	Declare @filtercomment bit
	Set @filtercomment =  0 

    -----------------------------------------------------------
    ------------------------ Коммутации -----------------------
    -----------------------------------------------------------
	if (@number ='') begin
	
   		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
				
   			Select top 30 sc.Id, sc.IdChain, null, 0, 
					sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
					'', '', 
					AUserId, BUserId, 
					ALineId, BLineId,
					AOutNumber, BOutNumber, 
					AStr, BStr
			From A_Stat_Connections_1x1 sc 
			Where (AUserId = @authorizeduserid  and  BUserId = @abonent)
			order by timestart desc 


   		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   			Select top 30 sc.Id, sc.IdChain, null, 0, 
				sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
				'', '', 
				AUserId, BUserId,
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where (AUserId = @abonent  and  BUserId = @authorizeduserid)
			--and TimeStop is not null
			Order by timestart desc 
	
	end else begin
   		
   		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	
   			Select  top 30 sc.Id, sc.IdChain, null, 0, 
				sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
				'', '', 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr
			From A_Stat_Connections_1x1 sc 
			Where (Boutnumber = @number and AUserId = @authorizeduserid)
			order by timestart desc 
			

   		Insert into #output ( Id, IdChain, Media, Type,
					TimeStart, Length,
					Number, AbonentName, 
					AUserId, BUserId, 
					ALineId, BLineId, 
					AOutNumber, BOutNumber, 
					AStr, BStr) 
					
   			Select top 30 sc.Id, sc.IdChain, null, 0, 
					sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
					'', '', 
					AUserId, BUserId,
					ALineId, BLineId, 
					AOutNumber, BOutNumber, 
					AStr, BStr
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where (Aoutnumber = @number  and  BUserId = @authorizeduserid)
			--and TimeStop is not null
			order by timestart desc 
	end


	-------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
	if (@number ='') begin
		
		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
				
			Select top 30 Idg, IdChain, 2, 0, 
				TimeStart, TimeStop - TimeStart, 
				AOutNumber, AStr,
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number
			From A_Stat_MissedCalls
			where (AUserId = @authorizeduserid  and  BUserId = @abonent) 
			order by timestart desc 
	
		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
				
			Select top 30 Idg, IdChain, 3, 3, 
				TimeStart, TimeStop - TimeStart, 
				AOutNumber, AStr,
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number
			From A_Stat_MissedCalls
			where (AUserId = @abonent  and  BUserId = @authorizeduserid)
			order by timestart desc 
		
	end else begin
		
		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)

			Select top 30 Idg, IdChain, 3, 3, 
				TimeStart, TimeStop - TimeStart, 
				AOutNumber, AStr,
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number
			From A_Stat_MissedCalls
			where ( BUserId = @authorizeduserid ) and ( AOutNumber = @number )
			order by timestart desc 
	end

--	-----------------------------------
--  	-- Преобразования -----------------
--	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @authorizeduserid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @authorizeduserid and o.BUserId = u.Id ) or ( o.BUserId = @authorizeduserid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @authorizeduserid )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = '00000000-0000-0000-0000-000000000000' )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
	(
		TimeStart deSC
	) WITH FILLFACTOR = 100 ON [PRIMARY]

     -- Подготовка параметров
     
	Select top 30	sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart,  
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName	
	From #output sc
	Order By TimeStart Desc

	Drop table #output
	
end
GO
