﻿if not ( object_id ( 'dbo.A_Stat_Connection_SetVoiceParams' ) is null )
	Drop procedure dbo.A_Stat_Connection_SetVoiceParams
GO

Create procedure [dbo].[A_Stat_Connection_SetVoiceParams]
	@dtstart datetime,
	@alinenum nvarchar(10),
	@blinenum nvarchar(10),
	@avms int,
	@bvms int
as
begin
	Declare @idconn uniqueidentifier, @lensec int, @anum nvarchar(10), @bnum nvarchar(10)

	Select @idconn = Id, 
		@lensec = Abs ( cast ( TimeStop - TimeAnswer as float ) * 86400 ), 
		@anum = ALineNum, 
		@bnum = BLineNum
	From dbo.A_Stat_Connections_1x1 sc
	Where TimeStart = @dtstart
		And (( ALineNum = @alinenum And BLineNum = @blinenum ) or 
		     ( ALineNum = @blinenum And BLineNum = @alinenum ))
		And not exists ( Select 1 From dbo.A_Stat_Connections_VoicePerc vp Where vp.idconn = sc.Id )

	if ( @@rowcount = 0 )
	    return

	Declare @ap int, @bp int, @as int, @bs int
	Select @ap = 0, @bp = 0, @as = 0, @bs = 0
	Select @ap = case when ( @avms + @bvms > 0 ) then @avms * 100 / ( @avms + @bvms ) else 0 end,
		@bp = case when ( @avms + @bvms > 0 ) then @bvms * 100 / ( @avms + @bvms ) else 0 end,
		@as = @avms / 1000,
		@bs = @bvms / 1000
	if ( @bvms > 0 )
		Set @bp = 100 - @ap

	if ( @anum = @alinenum )
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc, avsec, bvsec )
		Values ( @idconn, @lensec, @ap, @bp, @as, @bs )
	else
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc, avsec, bvsec )
		Values ( @idconn, @lensec, @bp, @ap, @bs, @as )
	
end
GO


if not ( object_id ( 'dbo.A_Stat_Set1x1VoiceMap' ) is null )
	Drop procedure dbo.A_Stat_Set1x1VoiceMap
GO

Create procedure [dbo].[A_Stat_Set1x1VoiceMap]
	@dtstart datetime,
	@alinenum nvarchar(10),
	@blinenum nvarchar(10),
	@amap image,
	@bmap image,
	@alen int,
	@blen int
as
begin

	Declare @idconn uniqueidentifier, @anum nvarchar(10), @bnum nvarchar(10)

	Select @idconn = Id, 
		@anum = ALineNum, 
		@bnum = BLineNum
	From dbo.A_Stat_Connections_1x1 sc
	Where TimeStart = @dtstart
		And (( ALineNum = @alinenum And BLineNum = @blinenum ) or 
		     ( ALineNum = @blinenum And BLineNum = @alinenum ))
		And not exists ( Select 1 From dbo.A_Stat_Connections_VoicePerc vp Where vp.idconn = sc.Id )

	if ( @@rowcount = 0 )
	    return
	    
	if ( @anum = @blinenum ) begin
	
		Insert into dbo.A_Stat_Connections_1x1_VoiceMap ( IdConn, AVoiceMap, BVoiceMap, ALen, BLen )
		Values ( @idconn, @bmap, @amap, @blen, @alen )
		
	end	else begin
	    
		Insert into dbo.A_Stat_Connections_1x1_VoiceMap ( IdConn, AVoiceMap, BVoiceMap, ALen, BLen )
		Values ( @idconn, @amap, @bmap, @alen, @blen )
	
	end
	
end
GO